-----------------------------------------------------------------------------

local AloftIsTargetData = Aloft:NewModule("IsTargetData", "AceEvent-2.0")

-----------------------------------------------------------------------------

AloftTagDirectAccessData.isTarget = true
AloftTagData.isTarget = { data = "isTarget", events = "Aloft:OnIsTargetDataChanged" }

function AloftIsTargetData:ProvidesData()
	return "isTarget"
end

function AloftIsTargetData:EnableDataSource()
	self:RegisterEvent("Aloft:OnNameplateHide", "OnNameplateHide")
	self:RegisterEvent("PLAYER_TARGET_CHANGED", "OnPlayerTargetChanged")
end

-----------------------------------------------------------------------------

local lastTarget = nil

function AloftIsTargetData:UpdateData(aloftData)
	aloftData.isTarget = aloftData:IsTarget()
	if aloftData.isTarget then
		lastTarget = aloftData
	end
end

function AloftIsTargetData:OnPlayerTargetChanged()
	if lastTarget then
		lastTarget.isTarget = nil
		self:TriggerEvent("Aloft:OnIsTargetDataChanged", lastTarget)
		lastTarget = nil
	end
	-- At this stage, the nameplates still haven't updated their alpha, so we have to do it on next frame
	self:ScheduleEvent("AloftIsTargetDataUpdate", self.Update, 0, self)
end

function AloftIsTargetData:Update()
	lastTarget = Aloft:GetTargetNameplate()
	if lastTarget then
		lastTarget.isTarget = true
		self:TriggerEvent("Aloft:OnIsTargetDataChanged", lastTarget)
	end
end

function AloftIsTargetData:OnNameplateHide(aloftData)
	if lastTarget == aloftData then
		lastTarget = nil
	end
end

-----------------------------------------------------------------------------
